<?php
  define('PHP_DIRECTORY', (session_save_path() . '/'));
  define('FRONTEND_DEBUG_FILE', (PHP_DIRECTORY . 'frontendDebugFile.txt'));
  define('FRONTEND_ERROR_LOG', (PHP_DIRECTORY . 'frontendErrorLog.txt'));
  define('AI_OUTPUT_FILE', (PHP_DIRECTORY . 'aiLastOutput.txt'));

  if (isset($_REQUEST['debugMode']) && $_REQUEST['debugMode'] == 'on')
    define('DEBUG_MODE', true);
  else
    define('DEBUG_MODE', false);

  if (isset($_REQUEST['advancedMode']) && $_REQUEST['advancedMode'] == 'on')
    define('ADVANCED_MODE', true);
  else
    define('ADVANCED_MODE', false);

  if (getenv('PHOENIX') != null)
    define('IS_PHOENIX', true);
  else
    define('IS_PHOENIX', false);

  if (getenv('HPDIAGS_CD') != null)
    define('IS_DIAGSCD', true);
  else
    define('IS_DIAGSCD', false);

  if (IS_PHOENIX || IS_DIAGSCD)
  {
    define('IS_OFFLINE', true);
    define('IS_ONLINE', false);
  }
  else
  {
    define('IS_OFFLINE', false);
    define('IS_ONLINE', true);
  }

  if (strstr(PHP_OS, 'Linux'))
  {
    define('IS_WINDOWS', false);
    define('IS_LINUX', true);
  }
  else
  {
    define('IS_WINDOWS', true);
    define('IS_LINUX', false);
  }

  if (IS_LINUX)
    define('DIAGS_DIRECTORY', '/opt/hp/hpdiags/');
  else if (IS_FACTORY)
    define('DIAGS_DIRECTORY', 'c:\\hp\\hpdiags\\');
  else
    define('DIAGS_DIRECTORY', '/hp/hpdiags/');

  define('DIAGCONFIG_PATH', (DIAGS_DIRECTORY . 'diagconfig.xml'));

  define('IDRESULT_PATH', (DIAGS_DIRECTORY . 'idResult.xml'));

  if (IS_LINUX)
    define('AI_PATH', (DIAGS_DIRECTORY . 'hpdiagsai'));
  else
    define('AI_PATH', (DIAGS_DIRECTORY . 'hpdiagsai.exe'));
    
  $supportedLanguages = array('en', 'fr', 'it', 'de', 'es', 'ja');
  $lang = 'en';
  if (isset($_GET['overrideLang']))
  {
    $overrideLang = $_GET['overrideLang'];
    if (in_array($overrideLang, $supportedLanguages))
    {
      $lang = $overrideLang;
      define('OVERRIDE_LANG', $lang);
    }
  }
  else
  {
    if (IS_OFFLINE)
    {
      $languageFile = '/root/compaq/language.txt';
      if (file_exists($languageFile))
      {
        $languageString = file_get_contents($languageFile);
        // we are only interested in the 1st three charcters
        $languageString = (strlen($languageString) > 3) ? substr($languageString, 0, 3) : $languageString;
        switch ($languageString)
        {
        case 'ENG':
          $lang = 'en';
          break;
        case 'FRE':
          $lang = 'fr';
          break;
        case 'ITA':
          $lang = 'it';
          break;
        case 'GER':
          $lang = 'de';
          break;
        case 'SPA':
          $lang = 'es';
          break;
        case 'JPN':
          $lang = 'ja';
          break;
        }
      }
    }
    else
    {
      $languageString = $_SERVER['HTTP_ACCEPT_LANGUAGE'];
      // we are only interested in the 1st two charcters
      $lang = (strlen($languageString) >= 2) ? substr($languageString, 0, 2) : 'en';
    }
    // if it's not one of our supported languages, set it to English
    if (!in_array($lang, $supportedLanguages))
      $lang = 'en';
  }
  define('LANG', $lang);

  if (isset($_SERVER['SCRIPT_URI']))
    $path = $_SERVER['SCRIPT_URI'];
  else
    $path = $_SERVER['SCRIPT_NAME'];

  $lastSlash = strrpos($path, '/');
  $baseURI = substr($path, 0, ($lastSlash + 1));
  define('FRONTEND_DIRECTORY', $baseURI);
  define('DOCUMENT_DIRECTORY', ($_SERVER['DOCUMENT_ROOT'] . FRONTEND_DIRECTORY));

  if (checkDiagConfig('/factory/configVerify') || (isset($_GET['cfg']) && $_GET['cfg'] == "1"))
    define('CONFIG_VERIFY', true);
  else
    define('CONFIG_VERIFY', false);

  if (CONFIG_VERIFY)
  {
    if (checkDiagConfig('/factory/configVerifyCloseOnFail'))
      define('CONFIG_VERIFY_CLOSE_ON_FAIL', true);
    else
      define('CONFIG_VERIFY_CLOSE_ON_FAIL', false);
  }

  function checkDiagConfig($tagname, $attributeName='', $attributeValue='')
  {
    $returnVal = false;
    $configFile = (DIAGS_DIRECTORY . 'diagconfig.xml');
    $xml = new DomDocument(file_get_contents($configFile));
    $xpath = xpath_new_context($xml->document_element());
    $tags = @ xpath_eval($xpath, $tagname);
    if (count($tags->nodeset)) // if we found the tag, continue
    {
      $returnVal = true;
      // if we are supposed to check for an attribute, do that now
      if ($attributeName != '')
      {
        $tag = $tags->nodeset[0]; // we will check only the first occurance of this tag
        $attribute = $tag->get_attribute($attributeName);
        if ($attribute == $attributeValue)
          $returnVal = true;
        else
          $returnVal = false;
      }
    }
    return $returnVal;
  }
?>
