function TestLogController()
{
  this.saveCommand   = 'commands/saveTestLog.php';
  //this.frame = getElement('testLogFrame');
  this.viewController = new ViewController('testLogFrame');
  this.viewURL = 'views/testLog.php';
  this.clearRequest = new ServerRequest('commands/clearTestLog.php');
  
  //this.shadowBox = new ShadowBox2(this, this.frame);
  this.shadowBox = this.viewController.shadowBox;
  
  this.init();
}

TestLogController.prototype.init = function init()
{
  var clearButton = getElement('clearTestLog');
  clearButton.controller = this;
  clearButton.action = function ()
  {
    this.controller.promptToClearLog(translate('MSG_ERROR_LOG'), this.controller);
  }

  var saveButton = getElement('saveTestLog');
  saveButton.controller = this;
  saveButton.action = function ()
  {
    Frontend.saveDialog.openDialog((translate('MSG_SAVE') + ' ' + translate('MSG_TEST_LOG')), 'testlog', this.controller);
  }
  
  this.clearRequest.controller = this;
  this.clearRequest.callback = function ()
  {
    this.controller.refreshFrame();
  }
}

TestLogController.prototype.refreshFrame = function refreshFrame()
{
  this.viewController.setURL(this.viewURL);
  /*
  this.shadowBox.show();
  var that = this;
  backgroundTask(function ()
  {
    var url = that.viewURL;
    var parameters = [];
    if (CONFIG.DEBUG_MODE == true)
      parameters.push('debugMode=on');
    if (CONFIG.OVERRIDE_LANG != undefined)
      parameters.push('overrideLang=' + CONFIG.OVERRIDE_LANG);
    if (parameters.length > 0)
      url += ('?' + parameters.join('&'));
    that.frame.src = url;
  });
  */
}

TestLogController.prototype.promptToClearLog = function promptToClearLog(title)
{
  var controller = this;
  var dialog = Frontend.dialog;
  dialog.toggleBadge(false);
  dialog.setHeader(title);
  dialog.toggleHeader(true);
  dialog.setContent(translate('MSG_CLEAR_LOG_CONFIRMATION'));
  dialog.toggleContent(true);
  dialog.clearButtons();
  dialog.addButton(translate('MSG_OK'), null, function ()
  {
    dialog.hide();
    controller.clearLog();
  });
  dialog.addButton(translate('MSG_CANCEL'), null, function ()
  {
    dialog.hide();
  });
  dialog.toggleButtons(true);
  dialog.show();
}

TestLogController.prototype.clearLog = function clearLog()
{
  this.clearRequest.send();
}

TestLogController.prototype.appendSaveInfo = function appendSaveInfo(request)
{
  return false;
}
/*
TestLogController.prototype.init = function init()
{
  this.refreshButton.controller = this;
  this.refreshButton.onclick = function ()
  {
    this.controller.refresh();
  }
  this.clearButton.controller = this;
  this.clearButton.onclick = function ()
  {
    this.controller.promptToClearLog(translate('MSG_TEST_LOG'), this.controller);
  }
  var saveButton = getElement('saveTestLog');
  saveButton.controller = this;
  saveButton.onclick = function ()
  {
    Frontend.saveDialog.openDialog((translate('MSG_SAVE') + ' ' + translate('MSG_TEST_LOG')), 'testlog', this.controller);
  }
  return this;
}

TestLogController.prototype.appendSaveInfo = function appendSaveInfo(request)
{
  return false;
}

/********************************************************************
//        NAME- DataRetriever.prototype.update
// DESCRIPTION- Called if data is updated properly, re-creates the
//              element with the new data
//      PASSED- 
//     RETURNS- 
//       NOTES- MUST be overloaded in descendent classes

TestLogController.prototype.update = function update()
{
  var key  = this.key;
  var data = this.data;
  var numberOfRecords = data.length;
  if (numberOfRecords <= 0)
  {
    this.thead.hide();
    clearChildren(this.tbody);
    var tr = this.tbody.appendChild(newElement('tr'));
    var message = (translate('MSG_TEST_LOG') + ' ' + translate('MSG_IS_EMPTY'));
    tr.appendChild(newElement('td', {'class':'message','text':message}));
  }
  else
  {
    this.thead.show();
    for (var i=0; i<numberOfRecords; i++)
    {
      var record = data[i];
      var tr = newElement('tr');
      // create icon entry
      var td = tr.appendChild(newElement('td', {'class':'icon'}));
      var result = record[key['result']];
      if (result == 'passed')
        var src = this.passedIcon;
      else if (result == 'failed')
        var src = this.failedIcon;
      else
        var src = this.unknownIcon;
      td.appendChild(newElement('img', {'src':src}));
      // create test entry
      var td = tr.appendChild(newElement('td', {'class':'test','text':record[key['test']]}));
      // create tested entry
      var td = tr.appendChild(newElement('td', {'class':'tested','text':record[key['tested']]}));
      // create failed entry
      var td = tr.appendChild(newElement('td', {'class':'failed','text':record[key['failed']]}));
      // create time entry
      var td = tr.appendChild(newElement('td', {'class':'time','text':record[key['time']]}));
      // create last entry
      var td = tr.appendChild(newElement('td', {'class':'last','text':record[key['last']]}));
            
      this.tbody.appendChild(tr);
    }
  }
}
*/